﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using NeonTea.Quakeball.Net.Packets;
using NeonTea.Quakeball.TeaNet.Peers;
using NeonTea.Quakeball.TeaNet.Packets;

namespace NeonTea.Quakeball.Net.Instances {
    public abstract class NetInstance {

        protected static byte[] Fingerprint = new byte[] { 0xFF, 0xF7 };

        public Peer Peer;
        public List<ulong> Connections = new List<ulong>();

        public abstract void Start(string address, int port, PeerMessageListener listener);
        public abstract void Connected(Connection conn);
        public abstract void Disconnected(Connection conn);
        public abstract void Handle(Connection conn, Packet packet);
        public abstract void UpdateLocalPlayer(PlayerUpdatePckt pckt);

        public void Stop() {
            if (Peer != null) {
                Peer.Stop();
                Peer.MessageListener.Message("Stopping");
                Peer = null;
            }
        }

    }
}